<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:eur="http://www.eurosion.org/metadataModel/" xmlns:iso19115="http://www.isotc211.org/iso19115/" xmlns:iso19103="http://www.isotc211.org/iso19103/" xmlns:iso19109="http://www.isotc211.org/iso19109/" xmlns:iso4217="http://www.isotc211.org/iso4217/" xmlns:iso639-2="http://www.isotc211.org/iso639-2/" xmlns:gml="http://www.opengis.net/gml" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<!-- Copy the main node -->
	<xsl:template match="metadata">
		<xsl:element name="eur:Metadata">
			<xsl:copy-of select="namespace::*"/>
			<xsl:attribute name="xsi:schemaLocation">http://www.eurosion.org/metadataModel/ H:\wp2\METADA~3\MetadataModel\SchemaDesign\XML\eurosion_metadata.xsd</xsl:attribute>
			<xsl:for-each select="@*[name(.) != 'ns']">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:apply-templates select="contInfo"/>
			<xsl:apply-templates select="appSchInfo"/>
			<xsl:apply-templates select="euroExt"/>
			<xsl:apply-templates select="gelosExt"/>
			<xsl:apply-templates select="giscoExt"/>
			<xsl:apply-templates select="dcmiExt"/>
			<xsl:apply-templates select="mdMaint"/>
			<xsl:apply-templates select="mdExtInfo"/>
			<xsl:apply-templates select="dataIdInfo"/>
			<xsl:apply-templates select="dqInfo"/>
			<xsl:apply-templates select="GridSpatRep | VectSpatRep"/>
			<xsl:apply-templates select="MdCoRefSys"/>
			<xsl:apply-templates select="distInfo"/>
			<xsl:apply-templates select="mdFileID"/>
			<xsl:apply-templates select="mdLang"/>
			<xsl:apply-templates select="mdChar2"/>
			<xsl:apply-templates select="mdParentID"/>
			<xsl:apply-templates select="mdHrLv2"/>
			<xsl:apply-templates select="mdHrLvName"/>
			<xsl:apply-templates select="mdContact"/>
			<xsl:apply-templates select="mdDateSt"/>
			<xsl:apply-templates select="mdStanName2"/>
			<xsl:apply-templates select="mdStanVer2"/>
		</xsl:element>
	</xsl:template>
	
	<!-- copy the nodes with the namespace -->
	<xsl:template match="*">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:for-each select="@*[name(.) != 'ns' and name(.) != 'Sync' and contains(name(.), 'Cd') = false]">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:for-each select="@xsi:type">
				<xsl:attribute name="{name(.)}">eur:<xsl:value-of select="."/></xsl:attribute>
			</xsl:for-each>
			<xsl:if test="count(*) > 0 or text()">
				<xsl:apply-templates/>
			</xsl:if>
		</xsl:element>
	</xsl:template>

	<!--xsl:template match="dataIdInfo">
		<xsl:choose>
			<xsl:when test="@xsi:type">
				<xsl:call-template name="replace_tpl">
					<xsl:with-param name="current" select="."/>
					<xsl:with-param name="name" select="'eur:Ident'"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="replace_tpl">
					<xsl:with-param name="current" select="."/>
					<xsl:with-param name="name" select="'eur:DataIdent'"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template-->
	
	<xsl:template match="dataIdInfo">
		<xsl:element name="eur:DataIdent">
			<xsl:apply-templates select="idAbs"/>
			<xsl:apply-templates select="idStatus"/>
			<xsl:apply-templates select="LegConsts"/>
			<xsl:apply-templates select="dsFormat"/>
			<xsl:apply-templates select="idSpecUse"/>
			<xsl:apply-templates select="resMaint"/>
			<xsl:apply-templates select="graphOver"/>
			<xsl:apply-templates select="descKeys"/>
			<xsl:apply-templates select="idCitation"/>
			<xsl:apply-templates select="idPurp"/>
			<xsl:apply-templates select="idCredit"/>
			<xsl:apply-templates select="idPoC"/>
			<xsl:apply-templates select="spatRpType"/>
			<xsl:apply-templates select="dataScale"/>
			<xsl:apply-templates select="dataChar"/>
			<xsl:apply-templates select="tpCat"/>
			<xsl:apply-templates select="dataExt"/>
			<xsl:apply-templates select="geoBox"/>
			<xsl:apply-templates select="geoDesc"/>
			<xsl:apply-templates select="dataLang"/>
			<xsl:apply-templates select="envirDesc"/>
			<xsl:apply-templates select="suppInfo"/>
		</xsl:element>
	</xsl:template>
	<!-- template for descKeys to read the attribute -->
	<xsl:template match="descKeys">
		<xsl:element name="eur:descKeys">
			<xsl:choose>
				<xsl:when test="keyTyp"><xsl:apply-templates/></xsl:when>
				<xsl:otherwise><xsl:apply-templates select="@KeyTypCd"/><xsl:apply-templates/></xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- template for data extent -->
	<xsl:template match="dataExt">
		<xsl:element name="eur:dataExt">
			<xsl:apply-templates select="vertEle"/>
			<xsl:apply-templates select="tempEle"/>
			<xsl:apply-templates select="GeoExtent | BoundPoly | GeoBndBox | GeoDesc"/>
			<xsl:apply-templates select="exDesc"/>
		</xsl:element>
	</xsl:template>
	<!-- template for vertical extent -->
	<xsl:template match="vertEle">
		<xsl:element name="eur:vertEle">
			<xsl:apply-templates select="vertUoM"/>
			<xsl:apply-templates select="vertMinVal"/>
			<xsl:apply-templates select="vertMaxVal"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="vertUoM">
		<xsl:element name="eur:vertUoM">
			<xsl:choose>
				<xsl:when test="uomName = 'Feet'">foot</xsl:when>
				<xsl:when test="uomName = 'Kilometers'">kilometer</xsl:when>
				<xsl:when test="uomName = 'Meters'">meter</xsl:when>
				<xsl:when test="uomName = 'Miles'">mile</xsl:when>
				<xsl:when test="uomName = 'Yards'">yard</xsl:when>
				<xsl:otherwise>meter</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- template for temporal extent -->
	<xsl:template match="tempEle">
	<xsl:element name="eur:tempEle">
		<xsl:element name="eur:exTemp">
			<xsl:for-each select="TempExtent/exTemp/TM_GeometricPrimitive/TM_Period">
				<xsl:element name="eur:beginEnd">
					<xsl:element name="eur:begin">
						<xsl:value-of select="substring(begin, 1, 4)"/>-<xsl:value-of select="substring(begin, 5, 2)"/>-<xsl:value-of select="substring(begin, 7, 2)"/>
						<xsl:choose>
						<xsl:when test="contains(begin, 'T')">
							<xsl:value-of select="'T'"/><xsl:value-of select="substring(begin, 10, 2)"/>:<xsl:value-of select="substring(begin, 12, 2)"/>:<xsl:value-of select="substring(begin, 14, 2)"/>
						</xsl:when>
						<xsl:otherwise>T00:00:00</xsl:otherwise>
						</xsl:choose>
					</xsl:element>
					<xsl:element name="eur:end">
						<xsl:value-of select="substring(end, 1, 4)"/>-<xsl:value-of select="substring(end, 5, 2)"/>-<xsl:value-of select="substring(end, 7, 2)"/>
					<xsl:choose>
						<xsl:when test="contains(end, 'T')">
							<xsl:value-of select="'T'"/><xsl:value-of select="substring(end, 10, 2)"/>:<xsl:value-of select="substring(end, 12, 2)"/>:<xsl:value-of select="substring(end, 14, 2)"/>
						</xsl:when>
						<xsl:otherwise>T00:00:00</xsl:otherwise>
					</xsl:choose>
					</xsl:element>
				</xsl:element>
			</xsl:for-each>
			<xsl:for-each select="TempExtent/exTemp/TM_GeometricPrimitive/TM_Instant/tmPosition/TM_DateAndTime/calDate">
				<xsl:element name="eur:instant">
					<xsl:value-of select="substring(., 1, 4)"/>-<xsl:value-of select="substring(., 5, 2)"/>-<xsl:value-of select="substring(., 7, 2)"/>
					<xsl:choose>
						<xsl:when test="../clkTime">
							<xsl:value-of select="'T'"/><xsl:value-of select="substring(../clkTime, 1, 2)"/>:<xsl:value-of select="substring(../clkTime, 3, 2)"/>:<xsl:value-of select="substring(../clkTime, 5, 2)"/>
						</xsl:when>
						<xsl:otherwise>T00:00:00</xsl:otherwise>
					</xsl:choose>
				</xsl:element>
			</xsl:for-each>
		</xsl:element>
	</xsl:element>
	</xsl:template>
	<!-- remove the uomScale -->
	<xsl:template match="uom">
		<xsl:element name="eur:uom">
			<xsl:apply-templates select="UomScale/*"/>
		</xsl:element>
	</xsl:template>
	<!-- Definition of a template to replace the name of current node -->
	<xsl:template name="replace_tpl">
		<xsl:param name="current"/>
		<xsl:param name="name"/>
		<xsl:element name="{$name}">
			<xsl:for-each select="@*[name(.) != 'ns' and name(.) != 'SYNC']">
				<xsl:choose>
					<xsl:when test="name(.) = 'xsi:type'">
						<xsl:attribute name="{name(.)}">eur:<xsl:value-of select="."/></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>
	<!-- Builds the Qname -->
	<xsl:template name="name_tpl">
		<xsl:variable name="ns" select="@ns"/>
		<xsl:choose>
			<xsl:when test="$ns = 'http://www.eurosion.org/metadataModel/'">eur:</xsl:when>
			<xsl:when test="$ns = 'http://www.isotc211.org/iso19115/'">iso19115:</xsl:when>
			<xsl:when test="$ns = 'http://www.isotc211.org/iso19103/'">iso19103:</xsl:when>
			<xsl:when test="$ns = 'http://www.isotc211.org/iso19109/'">iso19109:</xsl:when>
			<xsl:when test="$ns = 'http://www.isotc211.org/iso4217/'">iso4217:</xsl:when>
			<xsl:when test="$ns = 'http://www.isotc211.org/iso639-2/'">iso639-2:</xsl:when>
			<xsl:when test="$ns = 'http://www.opengis.net/gml'">gml:</xsl:when>
			<xsl:otherwise>eur:</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- replace the PresForm enum -->
	<xsl:template match="presForm">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="PresFormCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">documentDigital</xsl:when>
				<xsl:when test="$val = '002'">documentHardcopy</xsl:when>
				<xsl:when test="$val = '003'">imageDigital</xsl:when>
				<xsl:when test="$val = '004'">imageHardcopy</xsl:when>
				<xsl:when test="$val = '005'">mapDigital</xsl:when>
				<xsl:when test="$val = '006'">mapHardcopy</xsl:when>
				<xsl:when test="$val = '007'">modelDigital</xsl:when>
				<xsl:when test="$val = '008'">modelHardcopy</xsl:when>
				<xsl:when test="$val = '009'">profileDigital</xsl:when>
				<xsl:when test="$val = '010'">profileHardcopy</xsl:when>
				<xsl:when test="$val = '011'">tableDigital</xsl:when>
				<xsl:when test="$val = '012'">tableHardcopy</xsl:when>
				<xsl:when test="$val = '013'">videoDigital</xsl:when>
				<xsl:when test="$val = '014'">videoHardcopy</xsl:when>
				<xsl:when test="$val = '015'">collection</xsl:when>
				<xsl:when test="$val = '016'">dataset</xsl:when>
				<xsl:when test="$val = '017'">event</xsl:when>
				<xsl:when test="$val = '018'">image</xsl:when>
				<xsl:when test="$val = '019'">interactiveResource</xsl:when>
				<xsl:when test="$val = '020'">service</xsl:when>
				<xsl:when test="$val = '021'">software</xsl:when>
				<xsl:when test="$val = '022'">sound</xsl:when>
				<xsl:when test="$val = '023'">text</xsl:when>
				<xsl:otherwise>documentDigital</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the refDateType enum -->
	<xsl:template match="refDateType">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="DateTypCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">creation</xsl:when>
				<xsl:when test="$val = '002'">publication</xsl:when>
				<xsl:when test="$val = '003'">revision</xsl:when>
				<xsl:when test="$val = '004'">modified</xsl:when>
				<xsl:when test="$val = '005'">issued</xsl:when>
				<xsl:when test="$val = '006'">validation</xsl:when>
				<xsl:when test="$val = '007'">available</xsl:when>
				<xsl:otherwise>creation</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the role enum -->
	<xsl:template match="role">
		<xsl:element name="iso19115:role">
			<xsl:variable name="val"><xsl:for-each select="RoleCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">resourceProvider</xsl:when>
				<xsl:when test="$val = '002'">custodian</xsl:when>
				<xsl:when test="$val = '003'">owner</xsl:when>
				<xsl:when test="$val = '004'">user</xsl:when>
				<xsl:when test="$val = '005'">distributor</xsl:when>
				<xsl:when test="$val = '006'">originator</xsl:when>
				<xsl:when test="$val = '007'">pointOfContact</xsl:when>
				<xsl:when test="$val = '008'">principalInvestigator</xsl:when>
				<xsl:when test="$val = '009'">processor</xsl:when>
				<xsl:when test="$val = '010'">publisher</xsl:when>
				<xsl:when test="$val = '011'">author</xsl:when>
				<xsl:otherwise>resourceProvider</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the spatRpType enum -->
	<xsl:template match="spatRpType">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="spatRepTypCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">vector</xsl:when>
				<xsl:when test="$val = '002'">grid</xsl:when>
				<xsl:when test="$val = '003'">textTable</xsl:when>
				<xsl:when test="$val = '004'">tin</xsl:when>
				<xsl:when test="$val = '005'">stereoModel</xsl:when>
				<xsl:when test="$val = '006'">video</xsl:when>
				<xsl:otherwise>vector</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the tpCat enum -->
	<xsl:template match="tpCat">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="TopicCatCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">farming</xsl:when>
				<xsl:when test="$val = '002'">biota</xsl:when>
				<xsl:when test="$val = '003'">boundaries</xsl:when>
				<xsl:when test="$val = '004'">climatologyMeteorologyAtmosphere</xsl:when>
				<xsl:when test="$val = '005'">economy</xsl:when>
				<xsl:when test="$val = '006'">elevation</xsl:when>
				<xsl:when test="$val = '007'">environment</xsl:when>
				<xsl:when test="$val = '008'">geoscientificInformation</xsl:when>
				<xsl:when test="$val = '009'">health</xsl:when>
				<xsl:when test="$val = '010'">imageryBaseMapsEarthCover</xsl:when>
				<xsl:when test="$val = '011'">intelligenceMilitary</xsl:when>
				<xsl:when test="$val = '012'">inlandWaters</xsl:when>
				<xsl:when test="$val = '013'">location</xsl:when>
				<xsl:when test="$val = '014'">oceans</xsl:when>
				<xsl:when test="$val = '015'">planningCadastre</xsl:when>
				<xsl:when test="$val = '016'">society</xsl:when>
				<xsl:when test="$val = '017'">structure</xsl:when>
				<xsl:when test="$val = '018'">transportation</xsl:when>
				<xsl:when test="$val = '019'">utilitiesCommunication</xsl:when>
				<xsl:otherwise><xsl:value-of select="$val"/> farming</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the maintFreq enum -->
	<xsl:template match="maintFreq">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="MaintFreqCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">continual</xsl:when>
				<xsl:when test="$val = '002'">daily</xsl:when>
				<xsl:when test="$val = '003'">weekly</xsl:when>
				<xsl:when test="$val = '004'">fortnightly</xsl:when>
				<xsl:when test="$val = '005'">monthly</xsl:when>
				<xsl:when test="$val = '006'">quarterly</xsl:when>
				<xsl:when test="$val = '007'">biannually</xsl:when>
				<xsl:when test="$val = '008'">annually</xsl:when>
				<xsl:when test="$val = '009'">asNeeded</xsl:when>
				<xsl:when test="$val = '010'">irregular</xsl:when>
				<xsl:when test="$val = '011'">notPlanned</xsl:when>
				<xsl:when test="$val = '012'">unknown</xsl:when>
				<xsl:otherwise>continual</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the accessConsts enum -->
	<xsl:template match="accessConsts | useConsts">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="RestrictCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">copyright</xsl:when>
				<xsl:when test="$val = '002'">patent</xsl:when>
				<xsl:when test="$val = '003'">patentPending</xsl:when>
				<xsl:when test="$val = '004'">trademark</xsl:when>
				<xsl:when test="$val = '005'">license</xsl:when>
				<xsl:when test="$val = '006'">intellectualPropertyRights</xsl:when>
				<xsl:when test="$val = '007'">restricted</xsl:when>
				<xsl:when test="$val = '008'">otherRestrictions</xsl:when>
				<xsl:otherwise>copyright</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the keyTyp enum -->
	<xsl:template match="keyTyp">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="KeyTypCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">discipline</xsl:when>
				<xsl:when test="$val = '002'">place</xsl:when>
				<xsl:when test="$val = '003'">temporal</xsl:when>
				<xsl:when test="$val = '004'">stratum</xsl:when>
				<xsl:when test="$val = '005'">theme</xsl:when>
				<xsl:otherwise>discipline</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<xsl:template match="@KeyTypCd">
		<xsl:element name="eur:keyTyp">
			<xsl:variable name="val" select="."/>
			<xsl:choose>
				<xsl:when test="$val = '001'">discipline</xsl:when>
				<xsl:when test="$val = '002'">place</xsl:when>
				<xsl:when test="$val = '003'">stratum</xsl:when>
				<xsl:when test="$val = '004'">temporal</xsl:when>
				<xsl:when test="$val = '005'">theme</xsl:when>
				<xsl:otherwise>discipline</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the mdChar enum -->
	<xsl:template match="mdChar">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="CharSetCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">ucs2</xsl:when>
				<xsl:when test="$val = '002'">ucs4</xsl:when>
				<xsl:when test="$val = '003'">utf7</xsl:when>
				<xsl:when test="$val = '004'">utf8</xsl:when>
				<xsl:when test="$val = '005'">utf16</xsl:when>
				<xsl:when test="$val = '006'">8859part1</xsl:when>
				<xsl:when test="$val = '007'">8859part2</xsl:when>
				<xsl:when test="$val = '008'">8859part3</xsl:when>
				<xsl:when test="$val = '009'">8859part4</xsl:when>
				<xsl:when test="$val = '010'">8859part5</xsl:when>
				<xsl:when test="$val = '011'">8859part6</xsl:when>
				<xsl:when test="$val = '012'">8859part7</xsl:when>
				<xsl:when test="$val = '013'">8859part8</xsl:when>
				<xsl:when test="$val = '014'">8859part9</xsl:when>
				<xsl:when test="$val = '015'">8859part11</xsl:when>
				<xsl:when test="$val = '016'">8859part14</xsl:when>
				<xsl:when test="$val = '017'">8859part15</xsl:when>
				<xsl:when test="$val = '018'">jis</xsl:when>
				<xsl:when test="$val = '019'">shiftJIS</xsl:when>
				<xsl:when test="$val = '020'">eucJP</xsl:when>
				<xsl:when test="$val = '021'">usAscii</xsl:when>
				<xsl:when test="$val = '022'">ebcdic</xsl:when>
				<xsl:when test="$val = '023'">eucKR</xsl:when>
				<xsl:when test="$val = '024'">big5</xsl:when>
				<xsl:otherwise>ucs2</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the mdHrLv scpLvl enum -->
	<xsl:template match="mdHrLv | scpLvl">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="ScopeCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">attribute</xsl:when>
				<xsl:when test="$val = '002'">attributeType</xsl:when>
				<xsl:when test="$val = '003'">collectionHardware</xsl:when>
				<xsl:when test="$val = '004'">collectionSession</xsl:when>
				<xsl:when test="$val = '005'">dataset</xsl:when>
				<xsl:when test="$val = '006'">series</xsl:when>
				<xsl:when test="$val = '007'">nonGeographicDataset</xsl:when>
				<xsl:when test="$val = '008'">dimensionGroup</xsl:when>
				<xsl:when test="$val = '009'">feature</xsl:when>
				<xsl:when test="$val = '010'">featureType</xsl:when>
				<xsl:when test="$val = '011'">propertyType</xsl:when>
				<xsl:when test="$val = '012'">fieldSession</xsl:when>
				<xsl:when test="$val = '013'">software</xsl:when>
				<xsl:when test="$val = '014'">service</xsl:when>
				<xsl:when test="$val = '015'">model</xsl:when>
				<xsl:when test="$val = '016'">tile</xsl:when>
				<xsl:otherwise>attribute</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the orFunct enum -->
	<xsl:template match="orFunct">
		<xsl:element name="iso19115:orFunct">
			<xsl:variable name="val"><xsl:for-each select="OnFunctCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">download</xsl:when>
				<xsl:when test="$val = '002'">information</xsl:when>
				<xsl:when test="$val = '003'">offlineAccess</xsl:when>
				<xsl:when test="$val = '004'">order</xsl:when>
				<xsl:when test="$val = '005'">search</xsl:when>
				<xsl:otherwise>download</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- replace the dimName enum -->
	<!--xsl:template match="dimName">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="DimNameTypCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">row</xsl:when>
				<xsl:when test="$val = '002'">column</xsl:when>
				<xsl:when test="$val = '003'">vertical</xsl:when>
				<xsl:when test="$val = '004'">track</xsl:when>
				<xsl:when test="$val = '005'">crossTrack</xsl:when>
				<xsl:when test="$val = '006'">line</xsl:when>
				<xsl:when test="$val = '007'">sample</xsl:when>
				<xsl:when test="$val = '008'">time</xsl:when>
				<xsl:otherwise>row</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template-->
	<!-- replace the cellGeo enum -->
	<xsl:template match="cellGeo">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="CellGeoCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">point</xsl:when>
				<xsl:when test="$val = '002'">area</xsl:when>
				<xsl:otherwise>point</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- change the format of the refDate value -->
	<xsl:template match="refDate">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:value-of select="substring(., 1, 4)"/>-<xsl:value-of select="substring(., 5, 2)"/>-<xsl:value-of select="substring(., 7)"/>
		</xsl:element>
	</xsl:template>
	<!-- Replace the name -->
	<xsl:template match="mdChar2">
		<xsl:element name="eur:mdChar">
			<xsl:value-of select="."/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="mdHrLv2">
		<xsl:element name="eur:mdHrLv">
			<xsl:value-of select="."/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="mdStanName2">
		<xsl:element name="eur:mdStanName">
			<xsl:value-of select="."/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="mdStanVer2">
		<xsl:element name="eur:mdStanVer">
			<xsl:value-of select="."/>
		</xsl:element>
	</xsl:template>
	<!-- replace the uomName enum -->
	<xsl:template match="uomName">
		<xsl:element name="eur:uomName">
				<xsl:choose>
				<xsl:when test=". = 'Feet'">foot</xsl:when>
				<xsl:when test=". = 'Kilometers'">kilometer</xsl:when>
				<xsl:when test=". = 'Meters'">meter</xsl:when>
				<xsl:when test=". = 'Miles'">mile</xsl:when>
				<xsl:when test=". = 'Yards'">yard</xsl:when>
				<xsl:otherwise>meter</xsl:otherwise>
				</xsl:choose>
		</xsl:element>
	</xsl:template>
	<!-- add the qualified name because it is removed by esri -->
	<xsl:template match="rpIndName | rpOrgName | rpPosName | rpCntInfo | divisionUnit | cntPhone | voiceNum | faxNum | delPoint | city | adminArea | postCode | country | eMailAdd | cntOnlineRes | linkage | protocol | orName | orDesc | evalMethType | evalMethDesc | measDateTm | identCode | resTitle | dimName | dimSize | dimResol">
		<xsl:variable name="name">iso19115:<xsl:value-of select="name(.)"/></xsl:variable>
		<xsl:element name="{$name}">
			<xsl:if test="count(*) > 0 or text()">
				<xsl:apply-templates/>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<!-- order the idCitation node -->
	<xsl:template match="idCitation">
		<xsl:element name="eur:idCitation">
			<xsl:apply-templates select="resTitle"/>
			<xsl:apply-templates select="presForm"/>
			<xsl:apply-templates select="resAltTitle"/>
			<xsl:apply-templates select="resRefDate"/>
			<xsl:apply-templates select="resEd"/>
			<xsl:apply-templates select="resEdDate"/>
			<xsl:apply-templates select="citId"/>
			<xsl:apply-templates select="citRespParty"/>
			<xsl:apply-templates select="identifierType"/>
			<xsl:apply-templates select="isbn"/>
			<xsl:apply-templates select="issn"/>
		</xsl:element>
	</xsl:template>
	<!-- order the citRespParty node -->
	<xsl:template match="citRespParty">
		<xsl:element name="iso19115:citRespParty">
			<xsl:apply-templates select="role"/>
			<xsl:apply-templates select="rpIndName"/>
			<xsl:apply-templates select="rpOrgName"/>
			<xsl:apply-templates select="rpPosName"/>
			<xsl:apply-templates select="rpCntInfo"/>
			<xsl:apply-templates select="divisionUnit"/>
			<xsl:apply-templates select="citId"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="cntAddress">
		<xsl:element name="iso19115:cntAddress">
			<xsl:apply-templates select="delPoint"/>
			<xsl:apply-templates select="city"/>
			<xsl:apply-templates select="adminArea"/>
			<xsl:apply-templates select="postCode"/>
			<xsl:apply-templates select="country"/>
			<xsl:apply-templates select="eMailAdd"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="rpCntInfo">
		<xsl:element name="iso19115:rpCntInfo">
			<xsl:apply-templates select="cntPhone"/>
			<xsl:apply-templates select="cntAddress"/>
			<xsl:apply-templates select="cntOnlineRes"/>
		</xsl:element>
	</xsl:template>
	<!-- templates for the Quality records -->
	<xsl:template match="DQComplete | DQCompOm | DQCompleteComm | DQLogConsis | DQConcConsis | DQDomConsis | DQFormConsis | DQTopConsis | DQPosAcc | DQAbsExtPosAcc | DQGridDataPosAcc | DQRelIntPosAcc | DQTempAcc | DQAccTimeMeas | DQTempConsis | DQTempValid | DQThemAcc | DQNonQuanAttAcc | DQQuanAttAcc | DQThemClassCor">
		<xsl:element name="eur:{local-name(.)}">
			<xsl:apply-templates select="evalMethType"/>
			<xsl:apply-templates select="measName"/>
			<xsl:apply-templates select="measId"/>
			<xsl:apply-templates select="measDesc"/>
			<xsl:apply-templates select="evalMethDesc"/>
			<xsl:apply-templates select="evalProc"/>
			<xsl:apply-templates select="measDateTm"/>
			<xsl:apply-templates select="QuanResult | ConResult"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="measId">
		<xsl:element name="iso19115:measId">
			<xsl:apply-templates select="identAuth"/>
			<xsl:apply-templates select="identCode"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="identAuth">
		<xsl:element name="iso19115:identAuth">
			<xsl:apply-templates select="resTitle"/>
			<xsl:choose>
				<xsl:when test="resRefDate"><xsl:apply-templates select="resRefDate"/></xsl:when>
				<xsl:otherwise>
					<xsl:element name="iso19115:resRefDate">
						<xsl:element name="iso19115:refDateType">available</xsl:element>
						<xsl:element name="iso19115:refDate">2004-01-01</xsl:element>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="identifierType"><xsl:apply-templates select="identifierType"/></xsl:when>
				<xsl:otherwise>
					<xsl:element name="iso19115:identifierType"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<xsl:template match="_UnitOfMeasure">
		<xsl:variable name="recType" select="@xsi:type"/>
		<xsl:variable name="recName">
			<xsl:value-of select="substring($recType, 0, string-length($recType) - string-length('Type') + 1)"/>
		</xsl:variable>
		<xsl:element name="eur:{$recName}">
			<xsl:apply-templates select="uomName"/>
			<xsl:apply-templates select="uomSymbol"/>
		</xsl:element>
	</xsl:template>
	<!-- Replace the result tags by the parent measResult -->
	<xsl:template match="QuanResult">
		<xsl:element name="iso19115:measResult">
			<xsl:attribute name="xsi:type">eur:<xsl:value-of select="name()"/>Type</xsl:attribute>
			<xsl:apply-templates select="quanValType"/>
			<xsl:apply-templates select="_UnitOfMeasure"/>
			<xsl:apply-templates select="quanVal"/>
			<xsl:apply-templates select="errStat"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="ConResult">
		<xsl:element name="iso19115:measResult">
			<xsl:attribute name="xsi:type">eur:<xsl:value-of select="name()"/>Type</xsl:attribute>
			<xsl:apply-templates select="conExpl"/>
			<xsl:choose>
				<xsl:when test="conDesc"><xsl:apply-templates select="conDesc"/></xsl:when>
				<xsl:otherwise>
					<xsl:element name="eur:conSpec">
						<xsl:element name="iso19115:resTitle">not documented</xsl:element>
						<xsl:element name="iso19115:resRefDate">
							<xsl:element name="iso19115:refDateType">available</xsl:element>
							<xsl:element name="iso19115:refDate">2004-01-01</xsl:element>
						</xsl:element>
						<xsl:element name="iso19115:identifierType"/>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:apply-templates select="conPass"/>
		</xsl:element>
	</xsl:template>
	<!-- template for spatial representation -->
	<xsl:template match="GridSpatRep">
		<xsl:element name="eur:GridSpatRep">
			<xsl:apply-templates select="cellGeo"/>
			<xsl:apply-templates select="numDims"/>
			<xsl:apply-templates select="axDimProps"/>
			<xsl:apply-templates select="tranParaAv"/>
		</xsl:element>
	</xsl:template>
	<!-- replace the medName enum -->
	<xsl:template match="medName">
		<xsl:variable name="my_name">
			<xsl:call-template name="name_tpl"/>
		</xsl:variable>
		<xsl:element name="{$my_name}{name(.)}">
			<xsl:variable name="val"><xsl:for-each select="MedNameCd"><xsl:value-of select="@value"></xsl:value-of></xsl:for-each></xsl:variable>
			<xsl:choose>
				<xsl:when test="$val = '001'">cdRom</xsl:when>
				<xsl:when test="$val = '002'">dvd</xsl:when>
				<xsl:when test="$val = '003'">dvdRom</xsl:when>
				<xsl:when test="$val = '004'">3halfInchFloppy</xsl:when>
				<xsl:when test="$val = '005'">5quarterInchFloppy</xsl:when>
				<xsl:when test="$val = '006'">7trackTape</xsl:when>
				<xsl:when test="$val = '007'">9trackTape</xsl:when>
				<xsl:when test="$val = '008'">3480Cartridge</xsl:when>
				<xsl:when test="$val = '009'">3490Cartridge</xsl:when>
				<xsl:when test="$val = '010'">3580Cartridge</xsl:when>
				<xsl:when test="$val = '011'">4mmCartridgeTape</xsl:when>
				<xsl:when test="$val = '012'">8mmCartridgeTape</xsl:when>
				<xsl:when test="$val = '013'">1quarterInchCartridgeTape</xsl:when>
				<xsl:when test="$val = '014'">digitalLinearTape</xsl:when>
				<xsl:when test="$val = '015'">onLine</xsl:when>
				<xsl:when test="$val = '016'">satellite</xsl:when>
				<xsl:when test="$val = '017'">telephoneLink</xsl:when>
				<xsl:when test="$val = '018'">hardcopy</xsl:when>
				<xsl:otherwise><xsl:value-of select="$val"/>cdRom</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
